<template>
  <q-layout view="hHh lpR fFf">
    <q-header elevated>
      <q-toolbar>

        <q-btn
          v-if="false"
          flat
          dense
          round
          icon="menu"
          aria-label="Menu"
          @click="toggleLeftDrawer"
        />

        <q-btn flat label="Counter App" :to="{ name: 'home'}" />

        <q-space></q-space>
        <q-chip size="sm" class="q-mr-lg">v{{ packageJson.version }}</q-chip>

        <q-avatar v-if="user && user.photoURL" size="30px">
          <img :src="user.photoURL">
        </q-avatar>
        <q-btn v-if="!user" flat label="Login" :to="{ name: 'login' }" />
        <q-btn v-else flat label="Logout" @click="logout()" />
        
      </q-toolbar>
    </q-header>

    <!-- <q-drawer
      v-model="leftDrawerOpen"
      show-if-above
      bordered
    >
      <q-list>
        <q-item-label header>
          Menü
        </q-item-label>

      </q-list>
    </q-drawer> -->

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { defineComponent, ref as refVue, } from "vue";
import { mapGetters } from "vuex";
import { getDatabase, ref as refFb, get, onValue } from "firebase/database";
import { getAuth, signOut } from "firebase/auth";
import packageJson from '../../package.json';

export default defineComponent({
  name: "MainLayout",
  data: function () {
    return {
      times: [],
    };
  },
  computed: {
    ...mapGetters({
      user: "counter/getUser"
    }),
  },
  setup() {
    const leftDrawerOpen = refVue(false);

    return {
      packageJson,
      leftDrawerOpen,
      toggleLeftDrawer() {
        leftDrawerOpen.value = !leftDrawerOpen.value;
      },
    };
  },
  mounted() {
    // this.loadCommunitites();
  },
  async beforeRouteUpdate(to, from) {
    // this.loadCommunitites();
  },
  methods: {
    loadCommunitites() {

      const db = getDatabase();
      
      const communitiesRef = refFb(db, "communities/");
      onValue(communitiesRef, (snapshot) => {
        const data = snapshot.val();
        this.communitites = data;
      });
    },
    logout () {
      this.$store.dispatch('counter/logout').then(() => {
        console.log('Logged out...');
        this.$router.push({ name: 'home' });
      }).catch((err) => {
        console.error(err);
      });
    }
  },
  // mounted() {

    // const db = getDatabase();

    // const starCountRef = ref(db, "times/");

    // // onValue(starCountRef, (snapshot) => {
    // //   const data = snapshot.val();
    // //   Object.keys(data).forEach((entry) => {
    // //     this.times.push({ id: entry, label: data[entry].label });
    // //   });
    // // });

    // get(starCountRef, "times/")
    //   .then((snapshot) => {
    //     const data = snapshot.val();
    //     Object.keys(data).forEach((entry) => {
    //       this.times.push({ id: entry, label: data[entry].label });
    //     });
    //   })
    //   .catch((error) => {
    //     console.error(error);
    //   });

    // onValue(starCountRef, (snapshot) => {
    //   const data = snapshot.val();

    //   Object.keys(data).forEach(entry => {
    //     this.times.push({id: entry, label: data[entry].label});
    //   });

    // });
  // },
});
</script>
